<template>
  <div ref="formMultiSteps" class="form-multi-steps">
    <div class="form-multi-steps__header form-multi-steps-header mb-2">
      <div
        v-for="count in countStep"
        class="form-multi-steps-header__item"
        :class="{
          'form-multi-steps-header__item--isFirst': countStep <= 1,
          'form-multi-steps-header__item--active': isActive(count),
          'form-multi-steps-header__item--preview': isPreview(count)
        }"
      >
        <span
          class="form-multi-steps-header__step form-multi-steps-header-step"
        >
          <span class="form-multi-steps-header-step__item">{{ count }}</span>
        </span>
      </div>
    </div>
    <div class="form-multi-steps__content">
      <slot v-bind="$attrs" />
    </div>
    <div class="form-multi-steps__actions">
      <PrimeButton
        text
        label="Назад"
        class="w-full mr-2"
        :disabled="currentStep === 1"
        @click="prevStep"
      />
      <PrimeButton
        v-if="currentStep !== countStep"
        label="Далее"
        class="w-full"
        @click="nextStep"
      />
      <slot v-else name="submit" />
    </div>
  </div>
</template>

<script setup lang="ts">
const { values: formValues, validateField } = inject('form') as any
const formMultiSteps = ref()
const formMultiStepsContentSteps = ref()

const slots = useSlots() as any
const items = slots.default()

const props = defineProps({
  currentStep: {
    type: Number,
    required: false,
    default: 1
  },
  countStep: {
    type: Number,
    required: false,
    default: 0
  }
})

const currentStep = ref(props.currentStep)
const countStep = ref(items.length)

const currentMultiStepsItem = computed(
  () => formMultiStepsContentSteps.value[currentStep.value - 1]
)

const nextStep = async (e: Event) => {
  e.preventDefault()

  let isValidate = true

  for (const formValue in formValues) {
    const formItemHTML = currentMultiStepsItem.value.querySelector(
      `[name='${formValue}']`
    )

    if (!formItemHTML) continue

    const { valid } = await validateField(formItemHTML.getAttribute('name'))

    if (!valid) isValidate = valid
  }

  if (isValidate)
    toggleStep(formMultiStepsContentSteps.value[currentStep.value], 'next')
}
const prevStep = (e: Event) => {
  e.preventDefault()

  toggleStep(formMultiStepsContentSteps.value[currentStep.value - 2], 'prev')
}

const toggleStep = (nextElement: HTMLElement, type: 'prev' | 'next') => {
  if (!nextElement) return false

  nextElement.classList.add('form-multi-steps-step--active')
  currentMultiStepsItem.value.classList.remove('form-multi-steps-step--active')

  type === 'next' ? currentStep.value++ : currentStep.value--
}

const isActive = (count: number) => currentStep.value === count
const isPreview = (count: number) => currentStep.value > count

onMounted(() => {
  nextTick(() => {
    const formMultiStepsHTML: HTMLElement = formMultiSteps.value
    const formMultiStepsContentStepsHTML = formMultiStepsHTML.querySelectorAll(
      '.form-multi-steps__content .form-multi-steps-step'
    )

    if (
      !formMultiStepsContentStepsHTML ||
      formMultiStepsContentStepsHTML.length < 0
    )
      return

    formMultiStepsContentStepsHTML[currentStep.value - 1].classList.add(
      'form-multi-steps-step--active'
    )

    countStep.value = formMultiStepsContentStepsHTML.length
    formMultiStepsContentSteps.value = formMultiStepsContentStepsHTML

    document.onkeydown = function (e) {
      if (e.code === 'Tab') {
        nextStep(e)
      }
    }
  })
})
</script>

<style lang="scss" scoped>
.form-multi-steps {
  &-header {
    $header: &;
    position: relative;
    display: flex;
    justify-content: space-between;

    &__item {
      position: relative;
      display: flex;
      justify-content: center;
      flex: 1 1 auto;
      overflow: hidden;

      &::before {
        content: ' ';
        border-top: 1px solid #e2e8f0;
        width: 100%;
        top: 50%;
        display: block;
        position: absolute;
        border-top-width: 2px;
        left: 0;
      }

      &--isFirst {
        justify-content: center;
        display: flex;
        width: 100%;

        &::before {
          display: none;
        }
      }

      &:first-child {
        &::before {
          width: calc(50% + 1rem);
          transform: translateX(100%);
        }
      }

      &:last-child {
        &::before {
          width: 50%;
        }
      }

      &--active {
        #{$header}-step {
          background-color: $colorPrimary;

          &__item {
            color: #fff;
          }
        }

        &::before {
          border-color: $colorPrimary;
          background-color: #fff;
        }
      }

      &--preview {
        #{$header}-step {
          background-color: $colorPrimary;

          &__item {
            color: #fff;
          }
        }

        &::before {
          border-color: $colorPrimary;
          background-color: #fff;
        }
      }
    }

    &-step {
      position: relative;
      display: flex;
      justify-content: center;
      border: 1px solid $colorGray;
      border-radius: 50%;
      width: 30px;
      height: 30px;
      z-index: 1;
      background-color: $colorLight;

      &__item {
        position: relative;
        font-weight: 500;
        text-align: center;
        top: 4px;
      }
    }
  }

  &__actions {
    display: flex;
  }

  &__content {
    position: relative;
    display: grid;
    overflow: hidden;
  }
}
</style>
